diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/rendermisc.py sketch1/Sketch/UI/rendermisc.py
--- sketch.orig/Sketch/UI/rendermisc.py	1970-01-01 01:00:00.000000000 +0100
+++ sketch1/Sketch/UI/rendermisc.py	2005-03-22 00:02:36.000000000 +0100
@@ -0,0 +1,329 @@
+# NOTE: mit widget.window.draw_image(...) lassen sich gtk-imaghes
+# zeichnen. Mit graphicsdevice geht das eher schlecht. -> Renderer
+# Backends fuer gtk ?
+
+
+# Sketch - A Python-based interactive drawing program
+# Copyright (C) 1997, 1998, 1999, 2000, 2001, 2003 by Bernhard Herzog
+#
+# This library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Library General Public
+# License as published by the Free Software Foundation; either
+# version 2 of the License, or (at your option) any later version.
+#
+# This library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Library General Public License for more details.
+#
+# You should have received a copy of the GNU Library General Public
+# License along with this library; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""rendermisc
+
+Miscellaneous classes for rendering to pixmaps or to widgets,
+e.g. fill samples, lines, .... Renderer are derived from 3 general
+classes: PixmapRenderer, WidgetRenderer and CellRenderer. Specialised
+renderers are created by subclassing these baseclasses, implementing
+the methods 'default_size' and 'draw'.
+"""
+
+from types import StringType
+
+import gtk, gobject
+from gtk import gdk
+
+import Sketch
+from Sketch import _, Rect, Trafo, _skgtk
+from Sketch.Base import Publisher, preferences
+from Sketch.Graphics import StandardColors, LineStyle, EmptyLineStyle, \
+     PropertyStack,\
+     EmptyPattern, SolidPattern , CreateRGBColor
+from Sketch.const import CHANGED
+from gtkmisc import SketchDrawingArea
+from gtkdevice import PatternDevice, GraphicsDevice
+
+class Renderer:
+    default_size = 0,0
+    def __init__(self, data=None):
+        self.properties = PropertyStack()
+        self._data = data
+
+    def SetData(self, data):
+        self._data = data
+        
+    def draw(self, width, height):
+        """Do the drawing
+
+        This has to be implemented in the derived class"""
+        pass
+
+# This is the original implementation of widget renderer which also
+# works with pygtk < 2.4, however there are some rendering bugs which
+# I could not remove.
+
+class WidgetRenderer(SketchDrawingArea, Renderer):
+
+    def __init__(self,  data=None, **kw):
+        self.fill_rect = None
+        
+        Renderer.__init__(self, data)
+        apply(SketchDrawingArea.__init__, (self,), kw)
+
+        width, height = self.default_size
+        self.set_property("width-request", width)
+        self.set_property("height-request", height)
+
+    def compute_trafo(self):
+        width, height = self.get_size()
+        doc_to_win = Trafo(1, 0, 0, -1, 0, height)
+        win_to_doc = doc_to_win.inverse()
+        self.gc.SetViewportTransform(1.0, doc_to_win, win_to_doc)
+
+    def realize_method(self, *args):
+        apply(SketchDrawingArea.realize_method, (self,) + args)
+        self.gc.SetProperties(self.properties)
+
+    def RedrawMethod(self, region = None):
+        self.gc.gc.set_subwindow(0)
+        width, height = self.get_size()
+        #self.gc.StartDblBuffer()
+        self.gc.SetFillColor(StandardColors.white)
+        #self.gc.FillRectangle(0, 0, width, height)
+        self.gc.SetProperties(self.properties) # XXX needed ?
+        self.draw(width, height)
+        #self.gc.EndDblBuffer()
+
+    def ResizedMethod(self, width, height):        
+        width, height = self.get_size()
+        #self.fill_rect = Rect(0, 0, width, height)
+        self.gc.SetProperties(self.properties, self.fill_rect)
+        self.gc.WindowResized(width, height)
+        self.compute_trafo()
+        self.UpdateWhenIdle()
+
+# A widget renderer which works only from pygtk 2.4 on        
+class WidgetRenderer(Renderer, gtk.Widget):
+    __gsignals__ = { 'realize': 'override',
+                     'expose-event' : 'override',
+                     'size-allocate': 'override',
+                     'size-request': 'override',
+                     }
+    def __init__(self, data=None):
+        gtk.Widget.__init__(self)
+        Renderer.__init__(self, data)
+        self.gc = None
+        self.idle_redraw_tag = None
+        
+    def do_realize(self):
+        self.set_flags(self.flags() | gtk.REALIZED)
+
+        self.window = gdk.Window(self.get_parent_window(),
+                                 width=self.allocation.width,
+                                 height=self.allocation.height,
+                                 window_type=gdk.WINDOW_CHILD,
+                                 wclass=gdk.INPUT_OUTPUT,
+                                 event_mask= gdk.EXPOSURE_MASK)
+        self.gc = GraphicsDevice()
+        self.gc.init_gc(self.window, graphics_exposures = 1)
+        self.window.set_user_data(self)
+        self.style.attach(self.window)
+        self.style.set_background(self.window, gtk.STATE_NORMAL)
+        self.window.move_resize(*self.allocation)
+
+    def do_size_request(self, requisition):
+        width, height = self.default_size
+        requisition.width = width
+        requisition.height = height
+
+    def do_size_allocate(self, allocation):
+        self.allocation = allocation
+        if self.flags() & gtk.REALIZED:
+            self.window.move_resize(*allocation)
+
+    def redraw(self):
+        x0, y0, width, height = self.allocation
+        doc_to_win = Trafo(1, 0, 0, -1, 0, 0+height)
+        win_to_doc = doc_to_win.inverse()
+        self.gc.SetViewportTransform(1.0, doc_to_win, win_to_doc)        
+        self.draw(width, height)
+
+
+    def do_expose_event(self, event):
+        self.chain(event)
+        self.style.set_background(self.window, self.state)
+        self.window.clear()
+        self.redraw()
+        
+    def UpdateWhenIdle(self):
+        if self.idle_redraw_tag is None:
+            self.idle_redraw_tag = gtk.idle_add(self.idle_redraw)
+
+    def idle_redraw(self):
+        self.idle_redraw_tag = None
+        self.redraw()
+
+gobject.type_register(WidgetRenderer)
+
+class ImageRenderer(Renderer):
+    
+    def __init__(self, data=None):
+        Renderer.__init__(self, data)
+        self.gc = GraphicsDevice()        
+
+    def init_gc(self, window):
+        self.gc.init_gc(window)
+        
+    def CreateImage(self):
+        image = gtk.Image(self)
+        pixmap = self.create_pixmap()
+        bitmap = self.create_bitmap()
+        image.set_from_pixmap(pixmap, mask)        
+        return image
+
+    def create_pixmap(self):
+        width, height = self.default_size
+        gc = self.gc
+        pixmap = gtk.create_pixmap(gc.window, width, height)
+        gc.drawable = pixmap
+        doc_to_win = Trafo(1, 0, 0, -1, 0, height)
+        win_to_doc = doc_to_win.inverse()
+        gc.SetViewportTransform(1.0, doc_to_win, win_to_doc)
+        gc.ximage = None
+        self.draw(width, height)
+        gc.drawable = gc.window
+        return pixmap
+
+    def create_bitmap(self):
+        width, height = self.default_size        
+        create = gtk.gdk.bitmap_create_from_data
+        return create(self.gc.window, '\377'*(width*height/8), width, height)
+
+        
+                    
+
+class SketchCellRenderer(gtk.GenericCellRenderer, Renderer):
+
+    __gproperties__ = {
+        "data": (gobject.TYPE_PYOBJECT, "data",
+                 "cell data", 
+                 gobject.PARAM_READWRITE),
+    }
+
+    def __init__(self):
+        Renderer.__init__(self)
+        self.__gobject_init__()
+        self.gcs_initialized = 0
+        self.gc = GraphicsDevice()
+            
+    def init_gcs(self, window):
+        self.gc.init_gc(window, graphics_exposures = 1)
+        self.gcs_initialized = 1
+
+    def do_set_property(self, pspec, value):
+        setattr(self, pspec.name, value)
+ 
+    def do_get_property(self, pspec):
+        return getattr(self, pspec.name)
+                
+    def on_render(self, window, widget, background_area,
+                  cell_area, expose_area, flags):
+               
+        self.gc.drawable = window
+        if not self.gcs_initialized:
+            self.init_gcs(window)
+
+        data = self.get_property("data")
+        self.SetData(data)
+        
+        x0, y0, width, height = self.on_get_size(widget, cell_area)
+        x0 += cell_area.x
+        y0 += cell_area.y
+        doc_to_win = Trafo(1, 0, 0, -1, x0, y0+height)
+        win_to_doc = doc_to_win.inverse()
+        self.gc.SetViewportTransform(1.0, doc_to_win, win_to_doc)        
+        self.draw(width, height)
+        
+    def on_get_size(self, widget, cell_area):
+        xpad = self.get_property("xpad")
+        ypad = self.get_property("ypad")
+        if cell_area:
+            width = cell_area.width
+            height = cell_area.height
+            x_offset = xpad
+            y_offset = ypad
+        else:
+            default_w, default_h = self.default_size
+            width = self.get_property("width")
+            height = self.get_property("height")
+            if width == -1:
+                width = default_w
+            if height == -1:
+                height = default_h
+            width += xpad*2
+            height += ypad*2
+            x_offset = 0
+            y_offset = 0
+        return x_offset, y_offset, width, height
+
+gobject.type_register(SketchCellRenderer)
+
+
+class PatternSample:
+    default_size = 16, 16
+    def SetData(self, pattern):        
+        if pattern != self._data:
+            self._data = pattern
+            self.properties.SetProperty(fill_pattern = pattern)
+            self.gc.SetProperties(self.properties)
+
+    def draw(self, width, height):
+        w = width
+        h = height
+        if self.properties.HasFill():
+            self.gc.Rectangle(Trafo(w, 0, 0, h, 0, 0))
+        else:
+            self.gc.SetLineColor(StandardColors.black)
+            self.gc.DrawLineXY(0, h, w, 0)
+        
+        self.gc.DrawLineXY(0, 0, w-1, 0)
+        self.gc.DrawLineXY(0, h-1, w-1, h-1)
+        self.gc.DrawLineXY(0, 0, 0, h-1)
+        self.gc.DrawLineXY(w-1, 0, w-1, h-1)
+
+class ColorSample(PatternSample):
+    default_size = 16, 16
+    def SetData(self, color):        
+        if color is not None:
+            pattern = SolidPattern(color)            
+        else:
+            pattern = EmptyPattern
+        self.properties.SetProperty(fill_pattern = pattern)
+        self.gc.SetProperties(self.properties)
+
+class LineThicknessSample:
+    default_size = 16, 16
+    def draw(self, width, height):        
+        self.gc.SetProperties(self.properties)        
+        self.gc.SetLineAttributes(self._data)
+        self.gc.SetLineColor(StandardColors.black)
+        self.gc.DrawLineXY(0, height/2, width, height/2)
+    
+class _LinePropertySample:
+    """Common base class for several line sample classes."""
+    default_size = 16, 16
+    line_width = 2
+    attribute_name = ""
+    def draw(self, width, height):
+        self.gc.SetProperties(self.properties)
+        attributes = {}
+        attributes[self.attribute_name] = self._data
+        self.gc.SetLineAttributes(self.line_width, **attributes)
+        self.gc.SetFillColor(StandardColors.black)
+        self.gc.DrawLineXY(0, height/2, width, height/2)
+
+class DashesSample(_LinePropertySample):
+    default_size = 40, 10
+    attribute_name = 'dashes'
+
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/request.py sketch1/Sketch/UI/request.py
--- sketch.orig/Sketch/UI/request.py	1970-01-01 01:00:00.000000000 +0100
+++ sketch1/Sketch/UI/request.py	2005-03-19 20:27:08.000000000 +0100
@@ -0,0 +1,136 @@
+
+import gtk
+from Sketch import _, const
+from Sketch.Base import Publisher
+from Sketch.Graphics import CreateRGBColor
+
+
+class RequestHandler(Publisher):
+    def __init__(self, context):
+        self.colorpanel_count = 0
+        self.context = context
+        
+    def RequestColor(self, widget, color):
+        self.issue(const.CLEAR_REQUEST, widget)
+        self.issue(const.REQUEST_COLOR, color)
+        
+        # popup color panel        
+        if self.colorpanel_count == 0:
+            from colorpanel import ColorPanel
+            app = self.context.application
+            app.InstantiatePanel(ColorPanel)
+
+    def SetColor(self, color):
+        self.issue(const.SET_COLOR, color)
+        
+    def AddColorPanel(self):
+        self.colorpanel_count += 1
+
+    def RemoveColorPanel(self):
+        self.colorpanel_count -= 1
+        
+
+def _gtk_colors(cmap, color):
+    r, g, b = color
+    bg = cmap.alloc_color(int(round(r * 0xFFFF)),
+                          int(round(g * 0xFFFF)),
+                          int(round(b * 0xFFFF)))
+    luminance = 0.30*r + 0.59*g + 0.11*b
+    #luminance = (min(color) + max(color)) / 2
+    if luminance > 0.5:
+        fg = cmap.alloc_color(0, 0, 0)
+    else:
+        fg = cmap.alloc_color(0xFFFF, 0xFFFF, 0xFFFF)
+    return fg, bg
+
+
+#
+# This button triggers a color request
+#
+class ColorRequestButton(gtk.ToggleButton, Publisher):
+
+    def __init__(self, application, title, color):
+        gtk.ToggleButton.__init__(self, title)
+        self.connect("destroy", self.destroyed)
+        self.connect("toggled", self.toggled)
+        handler = application.RequestHandler()
+        handler.Subscribe(const.CLEAR_REQUEST, self.clear_request)
+        handler.Subscribe(const.SET_COLOR, self.set_color)
+        self.handler = handler
+        self.color = color
+
+    def destroyed(self, *args):
+        self.handler.Unsubscribe(const.CLEAR_REQUEST, self.clear_request)
+        self.handler.Unsubscribe(const.SET_COLOR, self.set_color)
+        self.handler = None
+        
+    def Color(self):
+        return self.color
+
+    def SetColor(self, color):
+        self.color = color
+
+    def toggled(self, *args):
+        if self.get_active():
+            self.handler.RequestColor(self, self.color)
+
+    def set_color(self, color):
+        if self.get_active():
+            self.SetColor(color)
+            self.issue(const.CHANGED, self.color)
+
+    def clear_request(self, widget):
+        if widget != self:
+            self.set_active(gtk.FALSE)
+
+    def Passivate(self):
+        self.set_active(gtk.FALSE)
+
+
+#
+# A color request button which displays the chosen color
+# and supports drag and drop
+#
+class ColorButton(ColorRequestButton):
+    dnd_target = [('application/x-color', 0, 0)]
+    def __init__(self, *args):
+        ColorRequestButton.__init__(self, *args)
+        self.connect("realize", self.realized)
+        self.connect('drag_data_received', self.drag_data_received)
+
+        self.drag_dest_set(gtk.DEST_DEFAULT_ALL, self.dnd_target,
+                                  gtk.gdk.ACTION_COPY | gtk.gdk.ACTION_MOVE)
+
+    def realized(self, *args):
+        self.SetColor(self.color)
+        
+    def SetColor(self, color):
+        ColorRequestButton.SetColor(self, color)
+        style = self.get_style().copy()
+        #print "color button: color=", color
+        fg, bg = _gtk_colors(self.get_colormap(), color)
+        for i in range(5):
+            style.fg[i] = fg
+            style.bg[i] = bg
+        self.set_style(style)
+        self.get_children()[0].set_style(style)
+
+    def drag_data_received(self, w, context, x, y, data, info, time):
+        d = data.data
+        if data and data.format == 16:
+            def decode(s):
+                b, a = map(ord, s)
+                return ((a << 8) + b)/ 65535.
+            bin = data.data
+            r = decode(bin[:2])
+            g = decode(bin[2:4])
+            b = decode(bin[4:6])
+
+            self.SetColor(CreateRGBColor(r, g, b))
+            context.finish(gtk.TRUE, gtk.FALSE, time)
+            self.issue(const.CHANGED, self.color)
+            
+        else:
+            context.finish(gtk.FALSE, gtk.FALSE, time)
+
+
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/skapp.py sketch1/Sketch/UI/skapp.py
--- sketch.orig/Sketch/UI/skapp.py	2005-03-19 18:48:56.000000000 +0100
+++ sketch1/Sketch/UI/skapp.py	2005-03-19 20:27:08.000000000 +0100
@@ -43,6 +43,7 @@
 from toolbox import SketchToolbox
 from menu import make_menu
 import gtkmisc
+import request
 
 #
 # meta info defaults
@@ -179,6 +180,7 @@
         self.file_dialog = None
         self.tooltips = gtk.Tooltips()
         self.context = AppContext(self)
+        self.requesthandler = request.RequestHandler(self.context)
         self.SetTool('SelectionTool')
 
         # Keep track of the open panels. To that end panels maps the
@@ -358,6 +360,9 @@
                                   accel = self.accelgroup)
         return self.menu
 
+    def RequestHandler(self):
+        return self.requesthandler
+
     def SetContext(self, window):
         self.context.SetWindow(window)
 
@@ -498,7 +503,22 @@
 Sketch.Editor.Add(Sketch.Editor.Command('object_panel',
                                         _("Object Panel"), object_panel))
 
+
+def layer_panel(context):
+    import layerpanel
+    context.application.InstantiatePanel(layerpanel.LayerPanel)
+
+Sketch.Editor.Add(Sketch.Editor.Command('layer_panel',
+                                        _("Layer Panel"), layer_panel))
+
+def inspector_panel(context):
+    import inspectorpanel
+    context.application.InstantiatePanel(inspectorpanel.InspectorPanel)
+
+Sketch.Editor.Add(Sketch.Editor.Command('inspector_panel',
+                                        _("Inspector Panel"), inspector_panel))
+
+                                                
 # import some development commands
 
 import devcmds
-
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/skpanel.py sketch1/Sketch/UI/skpanel.py
--- sketch.orig/Sketch/UI/skpanel.py	2005-03-19 18:48:56.000000000 +0100
+++ sketch1/Sketch/UI/skpanel.py	2005-03-19 22:12:46.000000000 +0100
@@ -1,3 +1,11 @@
+# TODO:
+# - rename this to "panel.py" ?
+# - with gtk2.4 it should be possible to change the behavior of
+#   ordinary windows so that they do stay above --> it is then possible
+#   to use gtk.Window instead of gtk.Dialog as base class for panel.
+
+
+
 # Sketch - A Python-based interactive drawing program
 # Copyright (C) 1999, 2000, 2001, 2003 by Bernhard Herzog
 #
@@ -16,12 +24,52 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+
+# Panels are in general windows which can be permanently openend and are
+# offering a certain functionality for the user. Examples include the toolbox,
+# the color panel, the inspector panel, etc. .
+#
+# The class "Panel" offers the simplest form of a panel: a bare
+# window. More complex panels are realized via the class
+# "MultiPanel". Using MulitPanels ensures a uniform look and
+# simplifies future modifications of the gui design, e.g. a switch
+# from SDI to MDI.  There is only one kind of widget which can be
+# placed into a MultiPanel: a "Card". If the panel holds several cards,
+# they are organized into a notebook. Cards can be attached or removed
+# at runtime.
+
+
 import gtk
 
 import Sketch
+from Sketch import _, const
+
+from Sketch.const import CHANGED, OBJECT_CHANGED, SELECTION
+
+from Sketch.Base import Publisher
 
-class SketchPanel(gtk.Dialog):
+# XXX:
+# from menu import MenuMixin
+from tmpmenu import MenuMixin
 
+import command
+from contextproxy import ContextProxy
+
+        
+# signal used when the panel is changed
+PANEL = "PANEL"
+
+class PanelContext(ContextProxy):
+    channels = ContextProxy.channels[:] + (PANEL,)
+    def __init__(self, panel, app_context):
+        self.panel = panel
+        ContextProxy.__init__(self, app_context)
+        panel.Subscribe(CHANGED, self.forward, PANEL)
+
+
+class Panel(gtk.Dialog):
+    """The basic panel class. New code should use MultiPanel instead. """
+    
     # if true, there can be multiple panels of this class, otherwise
     # only one.
     multiple = 0
@@ -32,17 +80,328 @@
         self.set_title(title)
         self.build_window()
         self.connect("destroy", self.destroyed)
-        self.context.Subscribe(Sketch.Base.const.CHANGED, self.context_changed)
+        self.connect("realize", self.realized)
+        self.context.Subscribe(const.CHANGED, self.context_changed)
 
     def build_window(self):
         pass
 
     def close(self, *args):
+        # XXX Do we really need this ?
         self.destroy()
 
+    def Close(self):
+        self.destroy()
+        
+    def Raise(self):        
+        # XXX the original "raise_" of gtk does not work with some
+        # windowmanagers. Hiding and showing the window does the same job.
+                
+        pos = self.get_position()
+        self.hide()
+        self.show()
+        self.move(*pos)
+
+    ### Callbacks
     def destroyed(self, *args):
-        self.context.Unsubscribe(Sketch.Base.const.CHANGED,
+        self.context.Unsubscribe(const.CHANGED,
                                  self.context_changed)
-                
+    
+    def realized(self, *args):
+        """Called when the widgets a are realized"""
+        pass
+
     def context_changed(self, *args):
         pass
+    
+
+# XXX "SketchPanel" should be replaced by "Panel". For the moment:
+SketchPanel = Panel
+
+class MultiPanel(Panel, Publisher):
+    auto_apply = 1
+    auto_update = 1
+
+    def __init__(self, context=None, title=""):
+        panel_context = PanelContext(self, context)
+        Panel.__init__(self, panel_context, title)
+    
+    def Duplicate(self):
+        clone = self.context.application.InstantiatePanel(self.__class__)
+        clone.auto_apply = self.auto_apply
+        clone.auto_update = self.auto_update
+        i = self.notebook.get_current_page()
+        clone.notebook.set_current_page(i)        
+        clone.changed()
+        clone.DoUpdate()
+        
+    def build_window(self):
+        self.header = gtk.HBox()
+        self.vbox.pack_start(self.header, expand=0)
+        self.notebook = gtk.Notebook()
+        self.notebook.set_property("homogeneous", 1)
+        
+        self.vbox.add(self.notebook)
+
+        self.menu = PanelMenu(self.context, allow_tearoff=0)
+        self.menu.show()
+        self.header.add(self.menu)
+
+        self.header.show()
+        self.vbox.show()
+        self.vbox.show()
+        self.notebook.show()
+                        
+    def set_menudata(self, data):        
+        self.menu.set_menudata(data)
+
+    def check_show_tabs(self):
+        childs = self.notebook.get_children()
+        if len(childs) > 1:
+            self.notebook.set_show_tabs(1)
+        else:
+            self.notebook.set_show_tabs(0)
+            
+    def attach_card(self, card):
+        assert isinstance(card, Card)        
+
+        label = gtk.Label(card.GetTitle())
+        self.notebook.append_page(card, label)
+        self.check_show_tabs()
+        card.Subscribe(const.CHANGED, self.changed)
+        card.attached(self)        
+        self.changed()
+
+    def detach_card(self, card):
+        self.notebook.remove(card)
+        self.check_show_tabs()
+        card.detached()
+        self.changed()
+
+    def changed(self):
+        """Notify that the panel has changed. """
+        self.issue(const.CHANGED)
+
+    def current_card(self):
+        children = self.notebook.get_children()
+        i = self.notebook.get_current_page()
+        if i >= 0:
+            return children[i]
+
+    ### commands
+    def ToggleAutoUpdate(self):
+        self.auto_update = not self.auto_update
+        self.changed()
+
+    def IsAutoUpdate(self):
+        return self.auto_update
+
+    def ToggleAutoApply(self):
+        self.auto_apply = not self.auto_apply
+        self.changed()
+
+    def IsAutoApply(self):
+        return self.auto_apply
+
+    def CanApply(self):
+        card = self.current_card()
+        if card is not None:
+            return card.CanApply()
+        return 0
+    
+    def DoApply(self, *args):
+        self.current_card().do_apply(all=1)
+        # inform the context that the state might have changed
+        self.changed()        
+
+    def DoUpdate(self):
+        self.current_card().update()                
+        # inform the context that the state might have changed
+        self.changed()
+
+    ### callbacks
+    def destroyed(self, *args):        
+        self.context.Destroy()
+        self.context = None
+        for card in self.notebook.get_children():
+            self.notebook.remove(card)
+            card.destroy()
+        
+
+class CardContext(ContextProxy):
+    def __init__(self, application):
+        self.panel = None
+        self.application = application
+        ContextProxy.__init__(self, application.context)
+        
+    def SetPanel(self, panel):
+        self.panel = panel
+
+    def UnsetPanel(self):
+        self.panel = None
+
+    def HasPanel(self):
+        return not self.panel is None
+    
+class Card(gtk.VBox, Publisher):
+    """A Card is a box which can be placed in a multipanel"""
+    
+    def __init__(self, application=None, title=None, duplicate=None):
+        if duplicate is not None:
+            application = duplicate.application
+            title = duplicate.title
+
+        gtk.VBox.__init__(self)
+        self.context = CardContext(application)
+        self.SetTitle(title)
+        self.build_card()
+        self.connect("realize", self.realized)
+        self.connect("destroy", self.destroyed)        
+
+    def Duplicate(self):
+        return self.__class__(duplicate=self)
+        
+    def build_card(self):
+        pass
+
+    def GetTitle(self):
+        return self.title
+
+    def SetTitle(self, title):
+        self.title = title
+        self.changed()
+
+    def HasPanel(self):
+        return self.context.HasPanel()
+    
+    def GetPanel(self):
+        if not self.context.HasPanel(): return
+        return self.context.panel
+
+    def IsAutoUpdate(self):
+        if not self.context.HasPanel(): return
+        return self.context.panel.auto_update
+
+    def IsAutoApply(self):
+        if not self.context.HasPanel(): return
+        return self.context.panel.auto_apply
+
+    def CanApply(self):
+        """Does the card have changes which can be applied ?"""
+        return 0
+    
+    def changed(self):
+        self.issue(const.CHANGED)
+
+    def update(self, *args):
+        """Update from selection"""
+        pass
+
+    def do_apply(self, all = 0):
+        """Apply all the changes"""
+        pass
+
+    ### callbacks
+    def realized(self, *args):
+        """Called when the widgets a are realized"""
+        pass
+    
+    def destroyed(self, *args):        
+        self.detached()
+        self.context.Destroy()
+
+    def detached(self):
+        """Called when the card is removed from a multipanel"""
+        self.context.UnsetPanel()
+        
+    def attached(self, panel):
+        """Called when the card is attached to a multipanel"""
+        self.context.SetPanel(panel)
+
+        
+#
+# Class PanelMenu
+#
+# Each panel should have panel menu. The menu is hidden under a button showing
+# an arrow.
+
+class PanelMenu(gtk.Table, MenuMixin):
+    def __init__(self, context, data=None, **kw):
+        MenuMixin.__init__(self, context, data, **kw)
+        gtk.Table.__init__(self, 3, 1)
+        
+        button = gtk.Button()
+        arrow = gtk.Arrow(gtk.ARROW_RIGHT, gtk.SHADOW_OUT)
+        button.add(arrow)
+        button.connect('button_press_event', self.show_menu)        
+        self.attach(button, 0, 1, 0, 1, 0, 0)
+        button.show()
+        arrow.show()
+        
+        spacer = gtk.HBox()
+        self.attach(spacer, 1, 2, 0, 1, xoptions=gtk.EXPAND)
+        
+        self.show_all()
+        self.show()
+        self.menu = gtk.Menu()
+
+    def add(self, widget):
+        """Put a widget right of the panel button"""
+        self.attach(widget, 2, 3, 0, 1, xoptions=0)
+        
+    def show_menu(self, widget, event):
+        """Popup the menu"""
+        self.menu.popup(None, None, None, event.button, event.time)
+        widget.emit_stop_by_name('button_press_event')
+
+    ### Methods called from MenuMixin:
+    def clear(self):
+        """Remove all gtk menu entries. Used by MenuMixin"""
+        for widget in self.menu.get_children():
+            self.menu.remove(widget)
+     
+    def append(self, menuitem):
+        """Append a gtk menu entry. Used by MenuMixin"""
+        self.menu.append(menuitem)
+                                                                           
+
+from Sketch.Editor import Command
+class PanelCommand(Command):
+    def Sensitive(self, context):
+        return context.panel is not None and Command.Sensitive(self, context)
+
+
+add = Sketch.Editor.Add
+cmd = PanelCommand
+
+# XXX remove this
+add(cmd('issue_panel_changed', _("Issue Changed"),
+        lambda context: context.panel.changed()))
+
+
+add(cmd('close_panel', _("Close"),
+        lambda context: context.panel.Close()))
+add(cmd('detach_card', _("Detach Card"),
+        lambda context: context.panel.current_card()))
+add(cmd('duplicate_panel', _("Duplicate"),
+        lambda context: context.panel.Duplicate(),
+        sensitive = lambda context: context.panel.multiple))
+add(cmd('update_panel', _("Update"),
+        lambda context: context.panel.DoUpdate(),
+        sensitive = lambda context: context.panel.CanApply(),
+        channels = (PANEL, SELECTION, OBJECT_CHANGED)))
+
+add(cmd('auto_update', _("Auto Update"),
+        lambda context: context.panel.ToggleAutoUpdate(),
+        checked = lambda context: context.panel.IsAutoUpdate(),
+        channels = (PANEL,)))
+add(cmd('auto_apply', _("Immediate Apply"),
+        lambda context: context.panel.ToggleAutoApply(),
+        checked = lambda context: context.panel.IsAutoApply(),
+        channels = (PANEL,)))
+add(cmd('do_apply', _("Apply"),
+        lambda context: context.panel.DoApply(),
+        sensitive = lambda context: context.panel.CanApply(),
+        channels = (PANEL, SELECTION, OBJECT_CHANGED)))
+    
+    
